Description

Si tenemos un campo que se llama igual que la capa, si ejecutamos la calculadora de campos sobre dicho campo salta error.

Ej.: Capa "Parcela" de Catastro, que tiene un campo "Parcela" de tipo texto. Si aplico la expresion:

TOINTEGER(Parcela)

salta error y no lo hace.

Adjunto SHP de ejemplo.

Associated revisions

Revision 44855 - 03/30/2020 06:49 PM - Joaquin del Cerro Murciano

refs #5199

Revision 44891 - 04/14/2020 02:10 PM - Oscar Martinez

refs #5199 los campos de tipo integer utilicen el método del formater para integers

Revision 44892 - 04/14/2020 06:45 PM - Oscar Martinez

refs #5199 los campos de tipo long utilicen el método del formater para long

Revision 44897 - 04/15/2020 02:58 AM - Oscar Martinez

refs #5199 Ahora usa el coercion

History

#1 - 03/26/2020 11:55 AM - Alvaro Anguix
- Target version set to 2.5.1-3044

Por lo que parece al poner en una expresion el nombre, no sabe si se refiere a la capa o al campo.
Da "Runtime error. Problems calling function 'TOINTEGER' with args "PARCELA")

#2 - 03/26/2020 02:02 PM - Joaquin del Cerro Murciano
- Priority changed from Normal to High

#3 - 03/26/2020 02:13 PM - Joaquin del Cerro Murciano
- Assignee set to Joaquin del Cerro Murciano

#4 - 03/26/2020 02:58 PM - Joaquin del Cerro Murciano
- Priority changed from High to Urgent

#5 - 03/28/2020 01:31 PM - Joaquin del Cerro Murciano
- Description updated

#6 - 03/30/2020 06:50 PM - Joaquin del Cerro Murciano
- Status changed from New to Fixed

#7 - 03/30/2020 06:58 PM - Joaquin del Cerro Murciano

Cuando se afiade una variable con el nombre de la tabla asociada a la expresion, ese nombre pasa a tener el valor de la tabla. Esto esta heco asi a
proposito ya que hay casos donde es necesario indicar de que tabla queremos coger los campos. El problema viene cuando hay un campo que se
llama igual que la tabla. En ese caso para el nombre nos devuelbe la tabla y no el campo, con lo que si no lo usamos en el contexto de una tabla nos
dara un error. Cuando se da este caso, podemos acceder al campo con "TABLA.CAMPQ".

He modificado el constructor de expresiones para que intente dar un mensaje de error mas acorde con lo que esta pasasndo, y pueda presentar
"sugerencias" que den pistas de cual puede ser el problema en caso de que el usuario no se de cuenta y solo ponga el nombre de la tabla cuando
este coincida con el de algun campo. Ademas he hecho que la busqueda simplificada, cuando construlle la expresion de busqueda use la
nomenclatura de "TABLA.CAMPQ", con lo que esta aparecera siempre en la pestafia de avanzado.

#8 - 03/31/2020 01:57 PM - Joaquin del Cerro Murciano
- Target version changed from 2.5.1-3044 to 2.5.1-3014

#9 - 04/10/2020 12:23 PM - Alvaro Anguix
- Status changed from Fixed to New

- File gvSIG.log.3 added

- File gvSIG.log.2 added

- File gvSIG.log.1 added

- File gvSIG.log added

Da errores. Desde la calculadora de campos le doy a aplicar y parece que funciona (se ve como se rellena la columna), pero al darle a aceptar se
quedan de nuevo los campos en blanco, y empiezan a aparecer errores en la barra de estado, dejando la capa en edicién.
Adjunto logs

#10 - 04/10/2020 12:54 PM - Joaquin del Cerro Murciano
- Target version changed from 2.5.1-3014 to 2.5.1-3015
#11 - 04/13/2020 01:18 PM - Joaquin del Cerro Murciano

- Assignee changed from Joaquin del Cerro Murciano to Oscar Martinez

#12 - 04/14/2020 03:13 AM - Oscar Martinez

El estado del error actual no esté relacionado con la calculadora de campos. Habian dos.

1) el error que aparece es por no poder transformar algunos valores del campo parcela porque contiene letras como A0 en el registro 300.

ERROR 79663 Thread-2 org.gvsig.scripting.app.extension.ScriptingUtils - Exception updated features:
org.gvsig.expressionevaluator.ExpressionRuntimeException: Problems calling function 'TOINTEGER' with args GETATTR

2) A la hora de cerrar edicion y formatear el campo Integer, no usaba el formateador adecuado del dbf para ese tipo.

#13 - 04/14/2020 02:11 PM - Oscar Martinez

- Status changed from New to Fixed

#14 - 04/16/2020 01:55 PM - Alvaro Anguix

- Status changed from Fixed to Closed

#15 - 05/05/2020 07:18 PM - Mario Fevre

Alguien podra decir si esta solucién resuelve un problema presente en el build 2915, por el cual da error seleccion por atributos de campos cuyo

nombre contenga espacios en blanco?

#16 - 05/05/2020 11:51 PM - Alvaro Anguix

Mario, he probado lo que dices en el build 3021 y no da error, por lo que el caso que comentas también parece resuelto.

#17 - 05/06/2020 10:33 AM - Mario Carrera

- File gvSIG-error.zip added

- File error-calccampos added

Lo he probado y lo hace bien, pero salta un error en la parte inferior. En el log no se ve error (aunque si que se han creado 3 ficheros log con el mismo

mensaje repetido muchas veces). En la consola si que se ve el error que ha saltado.

Adjunto captura con el error que salta en la consola por si es importante. Y adjunto los log también con el mensaje que se repite.

#18 - 05/06/2020 10:40 AM - Mario Carrera

Mario F., yo también he probado a hacer un filtro en el BN 3020 sobre un csv con espacios en los nombres de campo y lo ha hecho correctamente.

Si es sobre un shp es porque las tablas dbf no deben tener espacios, por lo que habria que renombrar el campo y quitar los espacios. Es posible que
te venga de una exportacion de otro formato y te haya mantenido los espacios.

¢Es ese el caso?
#19 - 05/06/2020 10:45 AM - Alvaro Anguix

Yo he renombrado un campo de un shape a un nombre con espacios "NAME LONG" y ha funcionado todo correcto.

Files

PARCELA.DBF 1.05 MB 03/11/2020 Mario Carrera
PARCELA.SHX 51.8 KB 03/11/2020 Mario Carrera
PARCELA.SHP 2.14 MB 03/11/2020 Mario Carrera
gvSIG.log 103 KB 04/10/2020 Alvaro Anguix
gvSIG.log.1 512 KB 04/10/2020 Alvaro Anguix
gvSIG.log.2 512 KB 04/10/2020 Alvaro Anguix
gvSIG.log.3 512 KB 04/10/2020 Alvaro Anguix
error-calccampos 68 KB 05/06/2020 Mario Carrera
gvSIG-error.zip 459 KB 05/06/2020 Mario Carrera
